/*******************************************************************************
 * Constants used for quick access to the Components object.
 ******************************************************************************/
const Cc = Components.classes;
const Ci = Components.interfaces;
const Cr = Components.results;
/*******************************************************************************
 * Main object that interacts between the user and the backend.
 ******************************************************************************/
var NewslivePrefs = {
  
  // nsISupports
  QueryInterface: function nlr_QI(iid) {
    if (iid.equals(Ci.nsISupports))
      return this;
    throw Cr.NS_ERROR_NO_INTERFACE; 
  },  
  
  _utils: null,
  get utils() { return this._utils; },
  set utils(val) { this._utils = val; },
    
  onLoad: function nlr_onLoad() {
  
    // get the util object
    this.utils = new NewsliveUtils();
    
    // get database file       
    this.getDBSize();       
  },
  
  onUnload: function nlr_onUnload() {
    
    // remove variables
    this.utils = null;
  },
  
  getDBSize: function nlr_getDBSize() {
    var dbFile = this.utils.nlService.databaseFile;
    var format, value;
    if (!dbFile) {
      format = "newslive.prefs.database.unknown";
      value = this.utils.getString(format);
    } else {
      var fileSize = dbFile.fileSize;
      var KB = parseInt(fileSize/1024);
      var MB = parseInt(KB/1024);
      if (MB > 0) {
        format = "newslive.prefs.database.MB";
        value = this.utils.getString(format, [MB]);
      } else if (KB > 0) {
        format = "newslive.prefs.database.KB";
        value = this.utils.getString(format, [KB]);
      } else {
        format = "newslive.prefs.database.B";
        value = this.utils.getString(format, [fileSize]);
      }
    }
    document.getElementById("database_label").value = value;
  },
  
  compactDB: function nlr_compactDB() {
    try {
      this.utils.nlService.compactDB();
      var label = this.utils.getString("newslive.prefs.database.unknown"); 
      document.getElementById("database_label").value = label; 
    } catch(e) {}
  }
};